/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"bytes"
	"encoding/json"
	"fmt"
)

// checks if the PasswordResetEmail type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PasswordResetEmail{}

// PasswordResetEmail struct for PasswordResetEmail
type PasswordResetEmail struct {
	Email        string `json:"email"`
	NewPassword  string `json:"newPassword"`
	IsEdhAccount bool   `json:"isEdhAccount"`
}

type _PasswordResetEmail PasswordResetEmail

// NewPasswordResetEmail instantiates a new PasswordResetEmail object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPasswordResetEmail(email string, newPassword string, isEdhAccount bool) *PasswordResetEmail {
	this := PasswordResetEmail{}
	this.Email = email
	this.NewPassword = newPassword
	this.IsEdhAccount = isEdhAccount
	return &this
}

// NewPasswordResetEmailWithDefaults instantiates a new PasswordResetEmail object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPasswordResetEmailWithDefaults() *PasswordResetEmail {
	this := PasswordResetEmail{}
	return &this
}

// GetEmail returns the Email field value
func (o *PasswordResetEmail) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *PasswordResetEmail) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *PasswordResetEmail) SetEmail(v string) {
	o.Email = v
}

// GetNewPassword returns the NewPassword field value
func (o *PasswordResetEmail) GetNewPassword() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.NewPassword
}

// GetNewPasswordOk returns a tuple with the NewPassword field value
// and a boolean to check if the value has been set.
func (o *PasswordResetEmail) GetNewPasswordOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.NewPassword, true
}

// SetNewPassword sets field value
func (o *PasswordResetEmail) SetNewPassword(v string) {
	o.NewPassword = v
}

// GetIsEdhAccount returns the IsEdhAccount field value
func (o *PasswordResetEmail) GetIsEdhAccount() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.IsEdhAccount
}

// GetIsEdhAccountOk returns a tuple with the IsEdhAccount field value
// and a boolean to check if the value has been set.
func (o *PasswordResetEmail) GetIsEdhAccountOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.IsEdhAccount, true
}

// SetIsEdhAccount sets field value
func (o *PasswordResetEmail) SetIsEdhAccount(v bool) {
	o.IsEdhAccount = v
}

func (o PasswordResetEmail) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PasswordResetEmail) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["email"] = o.Email
	toSerialize["newPassword"] = o.NewPassword
	toSerialize["isEdhAccount"] = o.IsEdhAccount
	return toSerialize, nil
}

func (o *PasswordResetEmail) UnmarshalJSON(data []byte) (err error) {
	// This validates that all required properties are included in the JSON object
	// by unmarshalling the object into a generic map with string keys and checking
	// that every required field exists as a key in the generic map.
	requiredProperties := []string{
		"email",
		"newPassword",
		"isEdhAccount",
	}

	allProperties := make(map[string]interface{})

	err = json.Unmarshal(data, &allProperties)

	if err != nil {
		return err
	}

	for _, requiredProperty := range requiredProperties {
		if _, exists := allProperties[requiredProperty]; !exists {
			return fmt.Errorf("no value given for required property %v", requiredProperty)
		}
	}

	varPasswordResetEmail := _PasswordResetEmail{}

	decoder := json.NewDecoder(bytes.NewReader(data))
	decoder.DisallowUnknownFields()
	err = decoder.Decode(&varPasswordResetEmail)

	if err != nil {
		return err
	}

	*o = PasswordResetEmail(varPasswordResetEmail)

	return err
}

type NullablePasswordResetEmail struct {
	value *PasswordResetEmail
	isSet bool
}

func (v NullablePasswordResetEmail) Get() *PasswordResetEmail {
	return v.value
}

func (v *NullablePasswordResetEmail) Set(val *PasswordResetEmail) {
	v.value = val
	v.isSet = true
}

func (v NullablePasswordResetEmail) IsSet() bool {
	return v.isSet
}

func (v *NullablePasswordResetEmail) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePasswordResetEmail(val *PasswordResetEmail) *NullablePasswordResetEmail {
	return &NullablePasswordResetEmail{value: val, isSet: true}
}

func (v NullablePasswordResetEmail) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePasswordResetEmail) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
